import { Controller, Get, Inject, Query } from '@midwayjs/decorator';
import { ApiTags } from '@midwayjs/swagger';
import { StatisticsService } from '../service/Statistics.service';
@ApiTags(['统计'])
@Controller('/Statistics')
export class StatisticsController {
  @Inject()
  service: StatisticsService;

  @Get('/order')
  async orderView() {
    const list = await this.service.order();
    return list;
  }

  @Get('/orderDetail')
  async orderDetail(@Query() filter: any) {
    const list = await this.service.orderDetail(filter);
    return list;
  }

  @Get('/user')
  async userView() {
    const list = await this.service.user();
    return list;
  }
}
