import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'Collection' },
})
export class Collection extends BaseModel {
  @prop({ required: true, index: false, zh: '街道/社区' })
  office: string;
  @prop({ required: true, index: false, zh: '领导' })
  leader: Array<any>;
  @prop({ required: true, index: false, zh: '会计' })
  accounting: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典表：is_use',
    default: '0',
  })
  is_use: string;
}
