import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'Good' },
})
export class Good extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表：good_type',
  })
  type: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '销售数量', default: '0' })
  sell_num: number;
  @prop({ required: false, index: true, zh: '供应商id' })
  supplier_id: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典表：is_use',
    default: '0',
  })
  is_use: string;
}
