import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'Office' },
})
export class Office extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '办公处名',
    remark: '街道社区通用',
  })
  name: string;
  @prop({ required: false, index: false, zh: '具体地址' })
  address: string;
  @prop({
    required: false,
    index: true,
    zh: '所属',
    // ref: 'Office',
    remark: '社区填写,街道不写',
  })
  belong: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典表 office_type',
  })
  type: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典表：is_use',
  })
  is_use: string;
}
