import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { Decimal128 } from 'mongoose';
@modelOptions({
  schemaOptions: { collection: 'Order' },
})
export class Order extends BaseModel {
  @prop({ required: false, index: true, zh: '用户' })
  user: string;
  @prop({ required: false, index: false, zh: '邮寄地址' })
  address: string;
  @prop({ required: false, index: false, zh: '商品' })
  goods: Array<any>;
  @prop({ required: false, index: false, zh: '总金额' })
  total_money: Decimal128;
  @prop({ required: false, index: true, zh: '下单时间' })
  buy_time: string;
  @prop({ required: false, index: false, zh: '审核记录' })
  record: Array<any>;
  @prop({ required: false, index: false, zh: '采购领导' })
  s_leader: Array<any>;
  @prop({ required: false, index: false, zh: '采购会计' })
  s_accounting: Array<any>;
  @prop({ required: false, index: false, zh: '回款领导' })
  c_leader: Array<any>;
  @prop({ required: false, index: false, zh: '回款会计' })
  c_accounting: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '订单状态',
    remark: '字典:order_status',
  })
  status: string;
}
