import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'OrderDetail' },
})
export class OrderDetail extends BaseModel {
  @prop({ required: false, index: true, zh: '总订单id' })
  order_id: string;
  @prop({ required: false, index: true, zh: '用户' })
  user: string;
  @prop({ required: false, index: true, zh: '商品id' })
  good: string;
  @prop({ required: false, index: true, zh: '规格id' })
  spec: string;
  @prop({ required: false, index: true, zh: '厂商id' })
  supplier: string;
  @prop({ required: false, index: false, zh: '收货地址' })
  address: string;
  @prop({ required: false, index: true, zh: '下单时间' })
  buy_time: string;
  @prop({ required: false, index: false, zh: '数量' })
  num: number;
  @prop({ required: false, index: true, zh: '单价金额' })
  money: number;
  @prop({ required: false, index: true, zh: '总价金额' })
  total_money: number;
  @prop({ required: false, index: false, zh: '审核记录' })
  record: Array<any>;
  @prop({ required: false, index: false, zh: '采购领导' })
  s_leader: Array<any>;
  @prop({ required: false, index: false, zh: '采购会计' })
  s_accounting: Array<any>;
  @prop({ required: false, index: false, zh: '回款领导' })
  c_leader: Array<any>;
  @prop({ required: false, index: false, zh: '回款会计' })
  c_accounting: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表 :order_status',
  })
  status: string;
}
