import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import { Decimal128 } from 'mongoose';
@modelOptions({
  schemaOptions: { collection: 'Specs' },
})
export class Specs extends BaseModel {
  @prop({ required: false, index: true, zh: '商品源' })
  goods: string;
  @prop({ required: false, index: true, zh: '规格名称' })
  name: string;
  @prop({ required: false, index: false, zh: '销售价格' })
  money: Decimal128;
  @prop({ required: false, index: false, zh: '库存' })
  num: number;
  @prop({ required: false, index: false, zh: '图片' })
  file: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典表：is_use',
    default: '0',
  })
  is_use: string;
}
