import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'Upkeep' },
})
export class Upkeep extends BaseModel {
  @prop({ required: false, index: true, zh: '订单id' })
  order_id: string;
  @prop({ required: true, index: true, zh: '用户id' })
  user: string;
  @prop({ required: false, index: true, zh: '用户名称' })
  user_name: string;
  @prop({ required: true, index: true, zh: '供应商id' })
  supplier: string;
  @prop({ required: false, index: true, zh: '供应商名称' })
  supplier_name: string;
  @prop({ required: true, index: true, zh: '商品id' })
  good: string;
  @prop({ required: false, index: true, zh: '商品名称' })
  good_name: string;
  @prop({ required: false, index: false, zh: '商品图片' })
  good_file: Array<any>;
  @prop({ required: true, index: true, zh: '规格id' })
  spec: string;
  @prop({ required: false, index: true, zh: '规格名称' })
  spec_name: string;
  @prop({ required: false, index: false, zh: '规格图片' })
  spec_file: Array<any>;
  @prop({ required: false, index: false, zh: '维修地址' })
  address: string;
  @prop({ required: false, index: true, zh: '申请时间' })
  apply_time: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表 :upkeep',
    default: '0',
  })
  status: string;
}
