import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_Cart {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '商品id' })
  'goods': string = undefined;
  @ApiProperty({ description: '供应商' })
  'supplier_id': string = undefined;
  @ApiProperty({ description: '商品规格id' })
  'spec': string = undefined;
  @ApiProperty({ description: '数量' })
  'num': number = undefined;
  @ApiProperty({ description: '单价金额' })
  'money': number = undefined;
  @ApiProperty({ description: '总价金额' })
  'total_money': number = undefined;
}

export class QDTO_Cart extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user', 'goods', 'supplier_id', 'spec', 'money'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '用户' })
  'user': string = undefined;
  @ApiProperty({ description: '商品id' })
  'goods': string = undefined;
  @ApiProperty({ description: '供应商' })
  'supplier_id': string = undefined;
  @ApiProperty({ description: '商品规格id' })
  'spec': string = undefined;
  @ApiProperty({ description: '总金额' })
  'money': number = undefined;
}

export class QVO_Cart extends FVO_Cart {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_Cart {
  @ApiProperty({ description: '用户' })
  @Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '商品id' })
  @Rule(RuleType['string']().empty(''))
  'goods': string = undefined;
  @ApiProperty({ description: '供应商' })
  @Rule(RuleType['string']().empty(''))
  'supplier_id': string = undefined;
  @ApiProperty({ description: '商品规格id' })
  @Rule(RuleType['string']().empty(''))
  'spec': string = undefined;
  @ApiProperty({ description: '数量' })
  @Rule(RuleType['number']().empty(''))
  'num': number = undefined;
  @ApiProperty({ description: '单价金额' })
  @Rule(RuleType['number']().empty(''))
  'money': number = undefined;
  @ApiProperty({ description: '总价金额' })
  @Rule(RuleType['number']().empty(''))
  'total_money': number = undefined;
}

export class CVO_Cart extends FVO_Cart {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_Cart extends CDTO_Cart {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_Cart extends FVO_Cart {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
