import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_Office {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '办公处名' })
  'name': string = undefined;
  @ApiProperty({ description: '具体地址' })
  'address': string = undefined;
  @ApiProperty({ description: '所属' })
  'belong': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_Office extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'belong', 'type', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '办公处名' })
  'name': string = undefined;
  @ApiProperty({ description: '所属' })
  'belong': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_Office extends FVO_Office {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_Office {
  @ApiProperty({ description: '办公处名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '具体地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '所属' })
  @Rule(RuleType['string']().empty(''))
  'belong': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_Office extends FVO_Office {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_Office extends CDTO_Office {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_Office extends FVO_Office {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
