import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import {
  BaseService,
  FrameworkErrorEnum,
  ServiceError,
} from 'free-midway-component';
import { Admin } from '../entity/Admin.entity';
import isEqual = require('lodash/isEqual');
import { LoginDTO } from '../interface/Admin.interface';
type modelType = ReturnModelType<typeof Admin>;
@Provide()
export class AdminService extends BaseService<modelType> {
  @InjectEntityModel(Admin)
  model: modelType;

  async findUserToLogin(data: LoginDTO): Promise<object> {
    const { username, password } = data;
    const user = await this.model.findOne({ username }, '+password').lean();
    if (!user)
      throw new ServiceError(
        '未找到管理员信息',
        FrameworkErrorEnum.NOT_FOUND_DATA
      );
    if (!isEqual(user.password.secret, password))
      throw new ServiceError('密码错误', FrameworkErrorEnum.SERVICE_FAULT);
    return user;
  }
}
