import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Good } from '../entity/Good.entity';
type modelType = ReturnModelType<typeof Good>;
interface infoInterface {
  name?: object;
  is_use?: string;
  type?: string;
}
@Provide()
export class GoodService extends BaseService<modelType> {
  @InjectEntityModel(Good)
  model: modelType;

  async search(filter): Promise<object> {
    const { name, is_use, type } = filter;
    const info: infoInterface = {
      name: { $regex: name || '' },
      is_use: is_use,
    };
    if (type) info.type = type;
    const list = await this.model.aggregate([
      {
        $match: info,
      },
      {
        $project: {
          _id: 1,
          name: 1,
        },
      },
    ]);
    return list;
  }
}
