import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import {
  BaseService,
  FrameworkErrorEnum,
  ServiceError,
} from 'free-midway-component';
import { Role } from '../entity/Role.entity';
type modelType = ReturnModelType<typeof Role>;
@Provide()
export class RoleService extends BaseService<modelType> {
  @InjectEntityModel(Role)
  model: modelType;

  async menu(is_use: string, code: string): Promise<object> {
    const menu = await this.model.findOne({ is_use, code }).lean();
    if (!menu)
      throw new ServiceError(
        '未找到菜单信息',
        FrameworkErrorEnum.NOT_FOUND_DATA
      );
    return menu;
  }
}
