import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Upkeep } from '../entity/Upkeep.entity';
import { OrderDetail } from '../entity/OrderDetail.entity';
type modelType = ReturnModelType<typeof Upkeep>;
@Provide()
export class UpkeepService extends BaseService<modelType> {
  @InjectEntityModel(Upkeep)
  model: modelType;

  @InjectEntityModel(OrderDetail)
  orderModel: ReturnModelType<typeof OrderDetail>;

  async createBefore(data) {
    const result = await this.orderModel.findById(data.order_id);
    if (result && result.status === '9')
      await this.orderModel.updateOne({ _id: data.order_id }, { status: '8' });
  }

  async update(id, body) {
    if (body.status === '2')
      await this.orderModel.updateOne({ _id: body.order_id }, { status: '10' });
    const result = await this.model.updateOne({ _id: id }, body);
    return result;
  }
}
